#pragma once
//-----------------------------------------------------------------------------
#ifndef _SCROLL_STATIC_H_
#define _SCROLL_STATIC_H_
//-----------------------------------------------------------------------------

#define I_HZN_TMR_MAX	80
#define I_HZN_TMR_MIN	1
#define I_HZN_TMR_BAS	30
#define I_VTC_TMR_MAX	10000
#define I_VTC_TMR_MIN	50
#define I_VTC_TMR_BAS	6000
//-----------------------------------------------------------------------------

#include <vector>

typedef std::vector<int> SCRTXTIDXLIST;
typedef std::vector<CObject*> TXTFRMLIST;
typedef std::vector<CObject*>::iterator TXTFRMLIST_ITER;
typedef std::vector<int> OFFSETLIST;

//-----------------------------------------------------------------------------
class CTxtFrm : public CObject
{
public:	
	CTxtFrm(CString strScrolTxt = _T(""), CString strLinkId = _T(""),int nDspDiv = 0);
	virtual ~CTxtFrm();

public:	
	CSize m_sizeTxt;	
	CString m_strLinkId;	// 
	CString m_strScrolTxt;	
	int m_nDspDiv;	
	//CArray<int,int> m_arrXOffSet;
	OFFSETLIST m_xOffSetList; 
};
//-----------------------------------------------------------------------------

class CScrollStatic : public CStatic
{
public:
	CScrollStatic();
	virtual ~CScrollStatic();

public:	
	BOOL			m_bMouseOverTxt;	
	TXTFRMLIST		m_TxtFrmList;
	COLORREF		m_clrForeTxt;
	COLORREF		m_clrOverTxt; 
	COLORREF		m_clrBackGround; 

public:		
	BOOL			BeginScrolling(CWnd* pOwnWnd = NULL,BOOL bReScrolling = TRUE);	
	BOOL			AddTxtFrm(CString strScrolTxt, CString strLinkId, int nDspDiv);	
	void			SetTimerEvent(BOOL bTimerOn);

	CWnd			*m_pWnd;	
	int				m_nHowScrollType;	
	BOOL			m_bMsgDispFin;	
	int				m_nTxtFrameIdx;

public:
	virtual BOOL	DestroyWindow();	
	void			ClickTxtFrm(CWnd* pOwnWnd,int nMsgId);						// ޼ Ŭ
	void			DelTxtFrm(BOOL bRePaint = TRUE);	
	void			GetNextMsg();	
	void			GetPrevMsg();	
	void			GetScrollCfg();												// ũ ⺻ȯ漳		
	void			SetChangeScrollType(int nHowScrollType,int nScrollSpeed);	// ũ Ÿ԰ ӵ 

protected:
	virtual void	PreSubclassWindow();
	afx_msg BOOL	OnEraseBkgnd(CDC* pClientDC);
	afx_msg void	OnPaint();
	afx_msg void	OnTimer(UINT nIDEvent);
	afx_msg void	OnSize(UINT nType,int cx,int cy);
	DECLARE_MESSAGE_MAP()

private:	
	void			CreateTxtFont(void);										// ũ ؽƮ Ʈ (PreSubclassWindow)
	void			CalcTxtArea(void);											//   ؽƮ  (PreSubclassWindow, OnSize)	
	void			InitScrFrame(void);											// ؽƮ ũ  ʱȭ(BeginScrolling)
	void			SetScrollNewPos(void);										// ũ ӵ   ũ ؽƮ ̵ ġ (OnTimer)	
	void			SetClippingRegion(CDC*);									//޼ CHypScr  ʰ ۾  Ŭ
	void			DrawScrTxt(CDC*);											//ؽƮ  ũ  	
	void			AddNewScr(void);											//ο ũ ؽƮ ߰
	void			DelScrFin(void);											//ũ  ؽƮ ε 	
	int				GetHoverTxtFrm(CPoint,int*);								//콺 ȣ ؽƮ  ε	
	int				GetSameItemIdx(SCRTXTIDXLIST&,int);							//ɼε, ũ 迭   ִ 	
	void			SetNextDsp();												//ũѸ 
	BOOL			DrawFixTxt(CDC* pClientDC, BOOL bGoNext = TRUE);			// Ǵ  ؽƮ 	

private:	
	BOOL m_bStaticMouseOver;	
	COLORREF m_clrPreTxtFrm;	
	UINT m_nScrollTimer; 			
	CRect m_rectScrolArea; 	
	CRect m_rectStaticCtrl;	
	CFont m_fntScrTxt; 	
	CFont m_fntUnderlineTxt;	
	CRect m_rectPreFrm;	
	int m_nOverPreFrmIdx;	
	int m_nOverTxtFrmIdx;		
	SCRTXTIDXLIST m_ScrTxtList;
	CClientDC* m_pClientDC;	
	CWnd* m_pOwnWnd;	
	BOOL m_bTimerOn;		

public:
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	int GetCurMsgIdx(void);

	//-----------------------------------------------------------------------------
	// by cscho
	// ؽƮ   ڿ
	CString			m_strPrefix;
	CSize			m_szPrefix;

	CString			m_strPrevArrow;
	CString			m_strNextArrow;
	CSize			m_szPrevArrow;
	CSize			m_szNextArrow;

	CString			GetPrefixString()						{ return m_strPrefix; }
	void			SetPrefixString(CString strPrefix)		{ m_strPrefix = strPrefix; }

	//  ؽƮ ǥ
	BOOL			m_bMultiText;
	int				m_nCurMultiIndex;

	BOOL			GetMultiText()						{ return m_bMultiText; }
	void			SetMultiText(BOOL bMulti)			{ m_bMultiText = bMulti; }
	int				GetMultiCurIndex()					{ return m_nCurMultiIndex; }
	void			SetMultiCurIndex(int nIdx)			{ m_nCurMultiIndex = nIdx; }

	//  ؽƮ / ȭǥ
	BOOL			m_bPrevArrowExist;
	CRect			m_rtPrevArrow;
	BOOL			m_bNextArrowExist;
	CRect			m_rtNextArrow;

	BOOL			ExistPrevTxtFrm();
	BOOL			ExistNextTxtFrm();
	BOOL			CheckLastScrTxtFrm(CTxtFrm* pTxtFrm);

	BOOL			m_bHoverPrevArrow;
	BOOL			m_bHoverNextArrow;
	BOOL			IsHoverPrevArrow(CPoint pntMouseCursor);	
	BOOL			IsHoverNextArrow(CPoint pntMouseCursor);
	void			UpdateHoverPrevArrow(BOOL bHoverPrev);
	void			UpdateHoverNextArrow(BOOL bHoverNext);

	int				m_nScrTxtIdxFirst;
	void			DoPrevTxtFrm();
	void			DoNextTxtFrm();
	BOOL			CalcScrTxtFrm();

	//-----------------------------------------------------------------------------	
	// by cscho
	//     
	BOOL			m_bTracking;

	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
	afx_msg void OnMouseHover(UINT nFlags, CPoint point);
	afx_msg void OnMouseLeave();
	//-----------------------------------------------------------------------------	
};
#endif
//-----------------------------------------------------------------------------
